<template>
  <div class="p-2">
    <transition :enter-active-class="proxy?.animate.searchAnimate.enter"
      :leave-active-class="proxy?.animate.searchAnimate.leave">
      <div v-show="showSearch" class="mb-[10px]">
        <el-card shadow="hover">
          <el-form ref="queryFormRef" :model="queryParams" :inline="true">

            <el-form-item label="评论内容" prop="comment">
              <el-input v-model="queryParams.comment" placeholder="请输入评论内容" clearable @keyup.enter="handleQuery" />
            </el-form-item>
            <el-form-item label="评论状态" prop="status">
              <el-select v-model="queryParams.status" placeholder="请选择评论状态" clearable>
                <el-option v-for="dict in is_publish" :key="dict.value" :label="dict.label" :value="dict.value" />
              </el-select>
            </el-form-item>
            <el-form-item label="发布时间" prop="commentTime">
              <el-date-picker clearable v-model="dateRange" value-format="YYYY-MM-DD HH:mm:ss" type="datetimerange"
                @clear="clearTime" :shortcuts="shortcuts" range-separator="-" start-placeholder="开始日期"
                end-placeholder="结束日期"
                :default-time="[new Date(2000, 1, 1, 0, 0, 0), new Date(2000, 1, 1, 23, 59, 59)]"></el-date-picker>
            </el-form-item>
            <el-form-item>
              <el-button type="primary" icon="Search" @click="handleQuery">搜索</el-button>
              <el-button icon="Refresh" @click="resetQuery">重置</el-button>
            </el-form-item>
          </el-form>
        </el-card>
      </div>
    </transition>

    <el-card shadow="never">
      <template #header>
        <el-row :gutter="10" class="mb8">
          <el-col :span="1.5">
            <el-button type="danger" plain icon="Delete" :disabled="multiple" @click="handleDelete()">删除</el-button>
          </el-col>
          <el-col :span="1.5">
            <el-button type="warning" plain icon="Download" @click="handleExport">导出</el-button>
          </el-col>
        </el-row>
      </template>

      <el-table v-loading="loading" :data="learningCommontList" @selection-change="handleSelectionChange">
        <el-table-column type="selection" width="55" align="center" />
        <el-table-column label="评论记录编号" align="center" prop="id" />
        <el-table-column label="评论内容" align="center" prop="comment" />
        <el-table-column label="所属帖子" align="center" prop="informationTitle" />
        <el-table-column label="评论状态" align="center" prop="status">
          <template #default="scope">
            <dict-tag :options="is_publish" :value="scope.row.status"></dict-tag>
          </template>
        </el-table-column>
        <el-table-column label="评论人" align="center" prop="expertName" />
        <el-table-column label="评论时间" align="center" prop="commentTime" >
        <template #default="scope">
            <span>{{ scope.row.commentTime.replaceAll('/','-') }}</span>
          </template>
        </el-table-column>

        <el-table-column label="撤销时间" align="center" prop="takedownTime" />
        <el-table-column label="操作" align="center" class-name="small-padding fixed-width">
          <template #default="scope">
            <!-- <el-tooltip content="修改" placement="top">
              <el-button link type="primary" icon="Edit" @click="handleUpdate(scope.row)"
                ></el-button>
            </el-tooltip>
            <el-tooltip content="删除" placement="top">
              <el-button link type="primary" icon="Delete" @click="handleDelete(scope.row)"
                ></el-button>
            </el-tooltip> -->

            <span @click="jumpTodetail(scope.row)" style="color: #409EFF;cursor: pointer;">查看</span>
            <el-divider direction="vertical"></el-divider>
            <span @click="updateJia(scope.row)" :style="scope.row.status == '3'?'color: #999;':'color: #409EFF;cursor: pointer'" >{{ scope.row.status == '1'?'发布':'撤销' }}</span>
            <el-divider direction="vertical"></el-divider>
            <span @click="handleDelete(scope.row)" style="color: #409EFF;cursor: pointer">删除</span>

          </template>
        </el-table-column>
      </el-table>

      <pagination v-show="total > 0" :total="total" v-model:page="queryParams.pageNum"
        v-model:limit="queryParams.pageSize" @pagination="getList" />
    </el-card>
    <!-- 添加或修改评论对话框 -->
    <el-dialog :title="dialog.title" v-model="dialog.visible" width="500px" append-to-body>
      <el-form ref="learningCommontFormRef" :model="form" :rules="rules" label-width="80px">
        <el-form-item label="id" prop="id">
          <el-input v-model="form.id" placeholder="请输入id" />
        </el-form-item>
        <el-form-item label="资讯id" prop="informationId">
          <el-input v-model="form.informationId" placeholder="请输入资讯id" />
        </el-form-item>
        <el-form-item label="评论人" prop="reviewerId">
          <el-input v-model="form.reviewerId" placeholder="请输入评论人" />
        </el-form-item>
        <el-form-item label="被回复人ID" prop="replyId">
          <el-input v-model="form.replyId" placeholder="请输入被回复人ID" />
        </el-form-item>
        <el-form-item label="评论" prop="comment">
          <el-input v-model="form.comment" placeholder="请输入评论" />
        </el-form-item>
        <el-form-item label="评论时间" prop="commentTime">
          <el-input v-model="form.commentTime" placeholder="请输入评论时间" />
        </el-form-item>
        <el-form-item label="状态" prop="status">
          <!-- <el-radio-group v-model="form.status">
            <el-radio
              v-for="dict in ${dictType}"
              :key="dict.value"
              :value="dict.value"
            >{{dict.label}}</el-radio>
          </el-radio-group> -->
        </el-form-item>
        <el-form-item label="备注" prop="remark">
          <el-input v-model="form.remark" placeholder="请输入备注" />
        </el-form-item>
      </el-form>
      <template #footer>
        <div class="dialog-footer">
          <el-button :loading="buttonLoading" type="primary" @click="submitForm">确 定</el-button>
          <el-button @click="cancel">取 消</el-button>
        </div>
      </template>
    </el-dialog>
  </div>
</template>

<script setup name="LearningCommont" lang="ts">
import { listLearningCommont, getLearningCommont, delLearningCommont, addLearningCommont, updateLearningCommont,updateStatus } from '@/api/study/comment';
import { LearningCommontVO, LearningCommontQuery, LearningCommontForm } from '@/api/study/comment/types';

const { proxy } = getCurrentInstance() as ComponentInternalInstance;
const router = useRouter();
const learningCommontList = ref<LearningCommontVO[]>([]);
const buttonLoading = ref(false);
const loading = ref(true);
const showSearch = ref(true);
const ids = ref<Array<string | number>>([]);
const single = ref(true);
const multiple = ref(true);
const total = ref(0);
const dateRange = ref<[DateModelType, DateModelType]>(['', '']);
const { is_publish, information_classify } = toRefs<any>(proxy?.useDict('is_publish', 'information_classify'));

const queryFormRef = ref<ElFormInstance>();
const learningCommontFormRef = ref<ElFormInstance>();

const dialog = reactive<DialogOption>({
  visible: false,
  title: ''
});

const initFormData: LearningCommontForm = {
  id: undefined,
  informationId: undefined,
  reviewerId: undefined,
  replyId: undefined,
  comment: undefined,
  commentTime: undefined,
  status: undefined,
  remark: undefined,
}
const shortcuts = [
  {
    text: '最近一周',
    value: () => {
      const end = new Date()
      const start = new Date()
      start.setDate(start.getDate() - 7)
      return [start, end]
    },
  },
  {
    text: '最近一月',
    value: () => {
      const end = new Date()
      const start = new Date()
      start.setMonth(start.getMonth() - 1)
      return [start, end]
    },
  },
  {
    text: '最近三月',
    value: () => {
      const end = new Date()
      const start = new Date()
      start.setMonth(start.getMonth() - 3)
      return [start, end]
    },
  },
]
const data = reactive<PageData<LearningCommontForm, LearningCommontQuery>>({
  form: { ...initFormData },
  queryParams: {
    pageNum: 1,
    pageSize: 10,
    informationId: undefined,
    reviewerId: undefined,
    replyId: undefined,
    comment: undefined,
    commentTime: undefined,
    status: undefined,
    params: {
    }
  },
  rules: {
    id: [
      { required: true, message: "id不能为空", trigger: "blur" }
    ],
    informationId: [
      { required: true, message: "资讯id不能为空", trigger: "blur" }
    ],
    reviewerId: [
      { required: true, message: "评论人不能为空", trigger: "blur" }
    ],
    replyId: [
      { required: true, message: "被回复人ID不能为空", trigger: "blur" }
    ],
    comment: [
      { required: true, message: "评论不能为空", trigger: "blur" }
    ],
    commentTime: [
      { required: true, message: "评论时间不能为空", trigger: "blur" }
    ],
    status: [
      { required: true, message: "状态不能为空", trigger: "change" }
    ],
    remark: [
      { required: true, message: "备注不能为空", trigger: "blur" }
    ],
  }
});

const { queryParams, form, rules } = toRefs(data);

/** 查询评论列表 */
const getList = async () => {
  loading.value = true;
  const res = await listLearningCommont(proxy?.addDateRange(queryParams.value, dateRange.value, 'start'));
  learningCommontList.value = res.rows;
  total.value = res.total;
  loading.value = false;
}
//跳转详情
const jumpTodetail = (row?)=>{
  const _id = row?.informationId;
  router.push({path:'/study/commentDetail',query:{id:_id}});
}
const clearTime = () => {
  dateRange.value = ['', ''];
  getList();
}
//修改状态
const updateJia = async (row)=>{
  if(row.status == '3'){
    return
  }
  row.status == '2'?row.status = '3':row.status = '2';
  const res = await updateStatus(row);

  if(res.code == 200){
    proxy?.$modal.msgSuccess("操作成功");
  }else{
    proxy?.$modal.msgError(`操作失败：${res.msg}`);
  }

}
/** 取消按钮 */
const cancel = () => {
  reset();
  dialog.visible = false;
}

/** 表单重置 */
const reset = () => {
  form.value = { ...initFormData };
  learningCommontFormRef.value?.resetFields();
}

/** 搜索按钮操作 */
const handleQuery = () => {
  queryParams.value.pageNum = 1;
  getList();
}

/** 重置按钮操作 */
const resetQuery = () => {
  dateRange.value = ['', ''];
  queryFormRef.value?.resetFields();
  handleQuery();
}

/** 多选框选中数据 */
const handleSelectionChange = (selection: LearningCommontVO[]) => {
  ids.value = selection.map(item => item.id);
  single.value = selection.length != 1;
  multiple.value = !selection.length;
}

/** 新增按钮操作 */
const handleAdd = () => {
  reset();
  dialog.visible = true;
  dialog.title = "添加评论";
}

/** 修改按钮操作 */
const handleUpdate = async (row?: LearningCommontVO) => {
  reset();
  const _id = row?.id || ids.value[0]
  const res = await getLearningCommont(_id);
  Object.assign(form.value, res.data);
  dialog.visible = true;
  dialog.title = "修改评论";
}

/** 提交按钮 */
const submitForm = () => {
  learningCommontFormRef.value?.validate(async (valid: boolean) => {
    if (valid) {
      buttonLoading.value = true;
      if (form.value.id) {
        await updateLearningCommont(form.value).finally(() => buttonLoading.value = false);
      } else {
        await addLearningCommont(form.value).finally(() => buttonLoading.value = false);
      }
      proxy?.$modal.msgSuccess("操作成功");
      dialog.visible = false;
      await getList();
    }
  });
}

/** 删除按钮操作 */
const handleDelete = async (row?: LearningCommontVO) => {
  const _ids = row?.id || ids.value;
  await proxy?.$modal.confirm('是否确认删除评论编号为"' + _ids + '"的数据项？').finally(() => loading.value = false);
  await delLearningCommont(_ids);
  proxy?.$modal.msgSuccess("删除成功");
  await getList();
}

/** 导出按钮操作 */
const handleExport = () => {
  proxy?.download('/zjk/learningCommont/export', {
    ...queryParams.value
  }, `learningCommont_${new Date().getTime()}.xlsx`)
}

onMounted(() => {
  getList();
});
</script>
